<?php

namespace App\Command;

use App\Entity\User;
use App\Entity\UserLog;
use Doctrine\ORM\EntityManager;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Component\Console\Attribute\AsCommand;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;
use Symfony\Component\Console\Style\SymfonyStyle;

#[AsCommand(
    name: 'app:update-all-users-cron',
    description: 'Add a short description for your command',
)]
class UpdateAllUsersCronCommand extends Command
{
    private EntityManager $entityManager;

    /**
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManagerInterface $entityManager)
    {
        $this->entityManager = $entityManager;
        parent::__construct();
    }

    protected function execute(InputInterface $input, OutputInterface $output): int
    {
        $em = $this->entityManager;
        $repo = $em->getRepository(User::class);

        $repo->createQueryBuilder('u')
            ->update()
            ->set('u.log', 0)
            ->where('u.log = 1')
            ->getQuery()
            ->execute();

        $repo->createQueryBuilder('u')
            ->update()
            ->set('u.log', 1)
            ->where('u.score > 900 OR u.score < 100')
            ->getQuery()
            ->execute();

        return Command::SUCCESS;
    }
}
